(* Copyright 2008, 2009 Michael Brunner *)

(* This file is part of LIPS.

  LIPS is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as 
	published by the Free Software Foundation, either version 3 of 
	the License, or (at your option) any later version.

  LIPS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
	License along with LIPS.  If not, see 
	<http://www.gnu.org/licenses/>. *)

type entry =
    Nfe of (CoreML.t * (CoreML.t * CoreML.pos list) list * CoreML.t)
  | TNfe of
      (CoreML.t * (CoreML.t * CoreML.pos list) list * CoreML.t * Type.t)
type t = entry list

type template 
val default : template

val tmplp : template -> template Parser.t

val to_strng : template -> entry list -> char list
